/*
    Copyright (C) 2000  DMark W. Webb (markwebb@adelphia.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



import java.net.*;
import java.io.*;
import java.util.Hashtable;

public class Download
{
  private String EOL = "\r\n";
  InputStream in;
  OutputStream out;
  Socket socket;
  String ip;
  String filename;
  int port;
  DownloadThread dt;
  
  public Download( String username, String filename, String size,
                       String speed, String ip, String port )
  {
    this.ip = ip;
    this.port = Integer.valueOf(port).intValue();
    this.filename = filename;
    
    try{
      socket = new Socket( ip, this.port );      
    }catch(SecurityException se){    System.out.println("Download: error trying to create download socket\n\t" + se );
    }catch(IOException ioe ){        System.out.println("Download: error trying to create download socket\n\t" + ioe );
    }
    
    StringBuffer sb = new StringBuffer();
    sb.append( "STP/1.0 GET" + EOL );
    sb.append( "User-Agent: JavaScour v0.1" + EOL );
    sb.append( "Username: " + username + EOL );
    sb.append( "Filename: " + filename + EOL );
//      sb.append( "Range: bytes=0-" + size + EOL );
//      sb.append( "Speed: " + speed + EOL );
//      sb.append( "IP: " + ip + EOL );
//      sb.append( "Port: " + port + EOL );
    sb.append( EOL );

    filename = filename.substring( filename.lastIndexOf( getSeparator(filename) )+1 );
    dt = new DownloadThread( MainWindow.getFrame(), sb.toString(), filename, size, ip, port);
    dt.start();
  }
  
  public void stop()
  {
    dt.stop();
  }
  
  public Download( String username, String filename, String size,
                        String ip, String port )
  {
    this.ip = ip;
    this.port = Integer.valueOf(port).intValue();
    this.filename = filename;
     
    try{
      socket = new Socket( ip, this.port );      
    }catch(SecurityException se){  System.out.println("Download: error trying to create download socket\n\t" + se );
    }catch(IOException ioe ){      System.out.println("Download: error trying to create download socket\n\t" + ioe );
    }

    StringBuffer sb = new StringBuffer();
    sb.append( "STP/1.0 GET" + EOL );
    sb.append( "User-Agent: JavaScour v0.1" + EOL );
    sb.append( "Username: " + username + EOL );
    sb.append( "Filename: " + filename + EOL );
    sb.append( "Range: bytes=0-" + size + EOL );
//      sb.append( "IP: " + ip + EOL );
//      sb.append( "Port: " + port + EOL );
    sb.append( EOL );
    
    filename = filename.substring( filename.lastIndexOf( getSeparator(filename) )+1 );
    DownloadThread dt = new DownloadThread( MainWindow.getFrame(), sb.toString(), filename, size, ip, port );
    dt.start();
  }

  private String getSeparator( String test )
  {
    if( test.indexOf("/") > 0 )
      return "/";
    else
      return "\\";
  } 
}
