/*
    Copyright (C) 2000  Mark W. Webb (markwebb@adelphia.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;

public class JavaScour implements ActionListener
{
  JFrame frame;
  JTextField user;
  JPasswordField password;
  JCheckBox newuser;
  JButton ok, cancel;
  
  public JavaScour()
  {
    frame = new JFrame( "JavaScour Login" );
    
    if( !startupFileFound() )
      {
	JPanel top = new JPanel();
	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	top.setLayout( gbl );
	c.insets = new Insets( 5, 7, 5, 7 );
	c.fill = GridBagConstraints.BOTH;
	c.weightx = 1.0;
	
	c.gridwidth = 1;
	top.add( new JLabel( "Username: " ));
	user = new JTextField( 30 );
	c.gridwidth = GridBagConstraints.REMAINDER;
	top.add( user, c );
	
	c.gridwidth = 1;
	password = new JPasswordField( 30 );
	c.gridwidth = GridBagConstraints.REMAINDER;
	top.add( new JLabel( "Password: "));
	top.add( password, c );
	
	c.gridwidth = 1;
	newuser = new JCheckBox();
	top.add( new JLabel ( "Log in as new user: "));
	c.gridwidth = GridBagConstraints.REMAINDER;
	top.add( newuser, c );
	
	frame.getContentPane().add( top, BorderLayout.NORTH );
	
	JPanel buttons = new JPanel();
	ok = new JButton( "Send" );
	ok.addActionListener( this );
	buttons.add( ok );
	
	cancel = new JButton( "Cancel" );
	cancel.addActionListener( this );
	buttons.add( cancel );
	
	frame.getContentPane().add( buttons, BorderLayout.SOUTH );

	frame.addWindowListener(new WindowAdapter() {
	    public void windowActivated(WindowEvent e) {}
	    public void windowClosed(WindowEvent e) {}
	    public void windowClosing(WindowEvent e) 
	    {
	      System.exit(0);
	    }
	    public void windowDeactivated(WindowEvent e) {}
	    public void windowDeiconified(WindowEvent e) {}
	    public void windowIconified(WindowEvent e) {}
	    public void windowOpened(WindowEvent e) {}});
	
	
	frame.pack();
	frame.setVisible( true );
      }
  }

  private boolean startupFileFound()
  {
    File startupFile = new File( System.getProperty("user.home") + System.getProperty("file.separator") + ".javascour");
    if( startupFile.exists() )
      {
	try{
	  FileInputStream fis = new FileInputStream( startupFile );
	  ObjectInputStream ois = new ObjectInputStream( fis );
	  StartUpInfo si = (StartUpInfo)ois.readObject();
	  Login login = new Login();
	  if( !login.canLogin( si.getUsername(), si.getPassword() ))
	    {
	      JOptionPane.showMessageDialog( frame, "There was a problem logging you into Scour", "Error", 
					     JOptionPane.ERROR_MESSAGE );
	    }
	  else
	    {
	      frame.setVisible( false );
	      MainWindow mw = new MainWindow( si.getUsername() );
	    }
	}catch(Exception e){
	  JOptionPane.showMessageDialog( frame, "There was a problem reported while reading startup file.\n" + 
					 e, "Error", JOptionPane.ERROR_MESSAGE );
	  return false;
	}
	return true;
      }
      else
    return false;
  }
  
  public void actionPerformed( ActionEvent e )
  {
    if( e.getSource() == ok )
      {
        if( newuser.isSelected() )
          {
            NewUserLogin nul = new NewUserLogin();
            if( !nul.createUser() )
              {
                JOptionPane.showMessageDialog( frame, "There was a problem creating your account", "Error", 
                                               JOptionPane.ERROR_MESSAGE );
              }
          }
        else 
          {
            Login login = new Login();
	    try{
	      FileOutputStream fos = new FileOutputStream( System.getProperty("user.home") + 
							   System.getProperty("file.separator") + ".javascour");
	      ObjectOutputStream oos = new ObjectOutputStream( fos );
	      StartUpInfo si = new StartUpInfo();
	      si.setUsername( user.getText().trim() );
	      si.setPassword( new String( password.getPassword() ).trim() );
	      oos.writeObject( si );
	    }catch(Exception ex){
	      JOptionPane.showMessageDialog( frame, "There was a problem reported while reading startup file.\n" + 
					     ex, "Error", JOptionPane.ERROR_MESSAGE );
	    }
	    
            if( !login.canLogin( (user.getText()).trim(), new String( password.getPassword())))
              {
                JOptionPane.showMessageDialog( frame, "There was a problem logging you into Scour", "Error", 
                                               JOptionPane.ERROR_MESSAGE );
              }
            else
              {
                frame.setVisible( false );
                MainWindow mw = new MainWindow( (user.getText()).trim() );
              }
          }
      }
    else if( e.getSource() == cancel )
      {
	System.exit( 0 );
      }
  }

  public static void main( String[] args )
  {
    JavaScour js = new JavaScour();
  }
}
