/*
    Copyright (C) 2000  DMark W. Webb (markwebb@adelphia.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



import java.io.*;

public class ParseStatInfo
{
  private String EOL = "\r\n";
  
  public ParseStatInfo()
  {
  }

  public void parse( BufferedReader is ) throws IOException
  {
    System.out.println(" **** STAT ****" );
    String ackreq, users, files, size;
    ackreq = is.readLine();
    System.out.println("STAT: ackerq = " + ackreq);
    
    boolean sendack = false;
    int colon = ackreq.indexOf(":");
    String suback = ackreq.substring( colon+1, ackreq.length() );
    System.out.println("Do we need to send an ACK -- " + suback );
    if( (suback.trim()).equals( "yes" ))
      sendack = true;
    else
      sendack = false;
    
    users = is.readLine();
    System.out.println("The total number of users = " + users.substring( users.indexOf(":")+1 ));

    files = is.readLine();
    System.out.println("The total number of shared files = " + files.substring( files.indexOf(":")+1));

    size = is.readLine();
    System.out.println("The total size of shared files = " + size.substring( size.indexOf(":")+1));

    String nothing = is.readLine();
    if( nothing.length() > 0 )
      System.out.println("STAT: nothing = " + nothing );

    if( sendack )
      {
        Ack ack = new Ack();
        ack.send();
      } 
  }
}
