/*
    Copyright (C) 2000  DMark W. Webb (markwebb@adelphia.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



import java.util.NoSuchElementException;

public class ResultTokenizer
{
  private int currentPosition;
  private int maxPosition;
  private String str;
  private String delimiter;
  private boolean retTokens;
  
  public ResultTokenizer(String str, String delim, boolean returnTokens) 
  {
    currentPosition = 0;
    this.str = str;
    maxPosition = str.length();
    delimiter = delim;
    retTokens = returnTokens;
  }

   public boolean hasMoreTokens() 
  {
    return (currentPosition < maxPosition);
  }
  
  public String nextToken() 
  {
    if (currentPosition >= maxPosition) 
      {
        throw new NoSuchElementException();
      }
    
    int start = currentPosition;
//      System.out.println("start = " + start + "   max = " + maxPosition );
    currentPosition = str.indexOf( delimiter, start+1);
    
    return str.substring(start, currentPosition);
  }
}

