/*
    Copyright (C) 2000  DMark W. Webb (markwebb@adelphia.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



import java.net.*;
import java.io.*;
import java.util.*;
import java.security.MessageDigest;

public class Search
{
  private String EOL = "\r\n";
  BufferedReader is;
  PrintStream os;
  
  public Search()
  {
  }
  
  public void getResults(SearchDataModel sdm, String media, String results, int connection, 
			 int duration, String queryString )
  {
//      System.out.println("Searching for " + queryString + " with a connection of " + connection + 
//                         " with a duration of " + duration + ", media type = " + media + 
//  		       " and a result count of " + results);
    
    is = (BufferedReader)ConnectionPool.get( "READER" );
    os = (PrintStream)ConnectionPool.get( "WRITER" );
        
    try{
      System.out.println("***** SEARCH *****" );
      
      StringBuffer search = new StringBuffer();
      
      search.append( "STP/1.0 SEARCH" + EOL );
      search.append("Search-ID: 1" + EOL);
      search.append("Type: " + media + EOL);
      search.append("Num-Results: " + results + EOL);
      search.append( "Query: " + queryString + EOL );
      search.append( "Duration: >" + duration + EOL );
      search.append("Speed: >" + connection + EOL);
      search.append(EOL);
      
      os.print( search.toString() );
      System.out.println(search);
      
      String result = null, searchid = null, type, offset, num;
      int numresults;
      
      boolean recieved = false;
      while( !recieved )
        {
          result = is.readLine();
          System.out.println("\n\nresult = " + result );
          
//        if( !(result.trim()).startsWith("STP/1.0 30" ))
          if( result.equals("STP/1.0 STAT") )
            {
              // we are recieving a STAT message...
              recieved = false;
              try{
                ParseStatInfo psi = new ParseStatInfo();
                psi.parse( is );
              }catch(IOException ioe){
                System.out.println("Search: " + ioe );
              }
            }
          else if( result.equals("STP/1.0 300 OK" ))
            {
//                System.out.println("********************");
//                System.out.println("recieved set to true");
//                System.out.println("result = " + result );
//                System.out.println("********************");
              recieved = true;
            }
          else
            return;
        }

//        System.out.println("*********************************");
//        System.out.println("** lets start parsing the results");
//        System.out.println("*********************************");
      
      searchid = is.readLine();
      type = is.readLine();
      type = type.substring( type.indexOf(":"));
      offset = is.readLine();
      offset = offset.substring( offset.indexOf(":")+1);
      num = is.readLine();
      num = num.substring(num.indexOf(":")+1);
      numresults = Integer.parseInt( num.trim() );
      
      StringBuffer buffer = new StringBuffer();
      String line = null;
      while( (line = is.readLine()).length() > 0 )
        {
          buffer.append( line + "\n" );
        }
      
      ResultTokenizer stz = new ResultTokenizer( buffer.toString(), "Filename", true );
      try{
        while( stz.hasMoreTokens() )
          {
            String searchresult = stz.nextToken();
            
            ResultTokenizer  tokenizer = new ResultTokenizer( searchresult.toString(), "\n", false );
            SearchResult sr =  new SearchResult();
            while( tokenizer.hasMoreTokens() )
              {
                String token = null;
                
                try{
                  token = (tokenizer.nextToken()).trim();
                }catch(StringIndexOutOfBoundsException ex){
                  break;
                }
                
                int colon = token.indexOf(":");
                String first = (token.substring(0, colon )).trim();
                String second = (token.substring( colon+1 )).trim();
                
                if( first.equals( "Filename" ))
                  {
                    String sep;
                    if( second.indexOf( "\\" ) > 0)
                      sep = "\\";
                    else 
                      sep = "/";
                    
                    String filename = (second.trim()).substring( second.lastIndexOf(sep)+1);
                    sr.add( first, filename );
                    String path = (second.trim()).substring( 0, second.lastIndexOf(sep));
                    sr.add( "Path", path );
                  }
                else
                  sr.add( first, second );
//              System.out.println("End of the while loop" );
              }
//          System.out.println("About to add a row");
            sdm.addRow( sr );
          }
      }catch(StringIndexOutOfBoundsException ex){
//          System.out.println("Search: " + ex.getMessage() );
      }
      
//        String nothing = is.readLine();
//        if( nothing.length() > 0 )
//      System.out.println("Search: nothing = " + nothing);
      
    }catch(Exception e){
      System.out.println(e);
    }
  }

  public void parseStatInfo( BufferedReader br ) throws IOException 
  {
    System.out.println(" **** STAT ****" );
    String ackreq, users, files, size;
    ackreq = is.readLine();
    System.out.println("STAT: ackerq = " + ackreq);
    
    boolean sendack = false;
    int colon = ackreq.indexOf(":");
    String suback = ackreq.substring( colon+1, ackreq.length() );
    System.out.println("Do we need to send an ACK -- " + suback );
    if( (suback.trim()).equals( "yes" ))
      sendack = true;
    else
      sendack = false;
    
    users = is.readLine();
//      System.out.println("STAT: users = " + users );
    System.out.println("The total number of users = " + users.substring( users.indexOf(":")+1 ));

    files = is.readLine();
//      System.out.println("STAT: files = " + files );
    System.out.println("The total number of shared files = " + files.substring( files.indexOf(":")+1));

    size = is.readLine();
//      System.out.println("STAT: size = " + size );
    System.out.println("The total size of shared files = " + size.substring( size.indexOf(":")+1));

    String nothing = is.readLine();
    if( nothing.length() > 0 )
      System.out.println("STAT: nothing = " + nothing );
    
//      System.out.println("STAT: sendack = " + sendack);
    if( sendack )
      ack();
  }

  public void ack()
  {
    try{
      System.out.println( "**** ACK ****");
      
      os.print( "STP/1.0 ACK" + EOL );
      System.out.println("STP/1.0 ACK");

      os.print( "User-Agent: JavaScour v0.1a" + EOL );
      System.out.println("User-Agent: JavaScour v0.1a");

      os.print( "Username: " + ConnectionPool.get( "USERNAME" ) + EOL );
      System.out.println("Username: " + ConnectionPool.get( "USERNAME" ));
      
      os.print( EOL );
//        System.out.println( "ack: " + is.readLine() );
    }catch(Exception e){
      System.out.println(e);
    }
  }
  
//    public void hello( BufferedReader is, PrintStream os )
//    {
//      try{
//        System.out.println( "**** HELO ****");
     
//        os.print("STP/1.0 HELO" + EOL );
//        System.out.println("STP/1.0 HELO");

//  //        System.out.println( "helo: " + is.readLine() );
//      }catch(Exception e){
//        System.out.println(e);
//      }
//    }
}
