/*
    Copyright (C) 2000  DMark W. Webb (markwebb@adelphia.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;


public class TransferPanel extends JPanel implements ActionListener, MouseListener
{
  TransferPanelDataModel tpdm;
  JTable table;
  JMenuItem adduser, cancel;
  JPopupMenu popupMenu;
  
  public TransferPanel()
  {
    super();
    this.setLayout( new BorderLayout() );
    
    /**
       extend a tablecell renderer...    do super()  for most of them,    your progressbar for your row, column
       i think the method is getCellRenderComponent()             
       {    Component c = super().getCellRenderCOmponent(  etc....  
       or 
       super.get...
       and if the row/column are right, substitute ur progressbar instead
    **/
    
    popupMenu = new JPopupMenu();
    adduser = new JMenuItem( "Add user to hotlist" );
    adduser.addActionListener( this );
    popupMenu.add( adduser );
    cancel = new JMenuItem( "Cancel download" );
    cancel.addActionListener( this );
    popupMenu.add( cancel );
    
    tpdm = new TransferPanelDataModel();
    table = new JTable( tpdm );
    table.addMouseListener( this );
    initializeColumns();
    
    add( new JScrollPane(table), "Center" );
  }
  
  public TransferPanelDataModel getDataModel()
  {
    return tpdm;
  }
  
  public void initializeColumns()
  {
  }

  public void mouseClicked(MouseEvent e) {}
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mousePressed(MouseEvent e) {  maybeShowPopup(e); }
  public void mouseReleased(MouseEvent e) { maybeShowPopup(e); }
  
  private void maybeShowPopup(MouseEvent e) 
  {
    if( table.getSelectedRow() == -1 )
      return;
    
    if( e.isPopupTrigger() ) 
      popupMenu.show(e.getComponent(), e.getX(), e.getY());
  }

  public void actionPerformed( ActionEvent e )
  {
    if( e.getSource() == adduser )
      {
        int row = table.getSelectedRow();
	if( row == -1 )
	  return;
	
        MainWindow.getHotListPanel().addUser( tpdm.getUsernameAt( row ));
        MainWindow.showPanel( MainWindow.HOTLIST );
      }
    else if( e.getSource() == cancel )
      {
	System.out.println("CANCEL DOWNLOAD");
      }
  }
}

