/*
    Copyright (C) 2000  Mark W. Webb (markwebb@adelphia.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



import javax.swing.*;
import java.io.*;
import javax.swing.event.*;
import java.util.*;

public class UserListModel extends AbstractListModel
{
  Vector mydata = null;
  
  public UserListModel()
  {
    super();
    mydata = new Vector();
  }
  
  public Object getElementAt( int i )
  {
    if ( mydata == null || i>= mydata.size() )
      return " ";
    return mydata.elementAt( i );
  }
  
  public boolean contains( Object o ){ return mydata.contains( o ); }
  public void print(){  System.out.println( mydata.toString() ); }
  public Vector getElements(){ return mydata; }
  public boolean isEmpty(){ return mydata.isEmpty(); }
  public int getSize(){ return mydata.size(); }

  public void remove( int i )
  {
    mydata.remove( i );
    if( getSize() != 0 )
      fireIntervalAdded( this, 0, getSize()-1 );
    fireIntervalAdded( this, 0, 0 );
  }
  
  public void remove( Object o )
  {
    boolean b = mydata.remove( o );
    if( getSize() != 0 )
      {
         fireIntervalAdded( this, 0, getSize()-1 );
      }
    fireIntervalAdded( this, 0, 0 );
  }
  
  public void clear( )
  {
    mydata.clear();
    if( getSize() != 0 )
      fireIntervalAdded( this, 0, getSize()-1 );
    fireIntervalAdded( this, 0, 0 );
  }
  
  public void addElement( Object o )
  {
    if( getSize() != 0 )
      fireIntervalRemoved( this, 0, getSize()-1 );
    fireIntervalRemoved( this, 0, 0 );
    if( !contains( o ))
      mydata.add( o );
    fireIntervalAdded( this, 0, getSize()-1 );
  }

  public void addElements( Vector v )
  {
    Object[] array = v.toArray();
    for( int i = 0; i < array.length; i++ )
      { 
        if( !contains( array[i] ))
          addElement( array[i] );
      }
  }

  public void addElements( Object[] o )
  {
    if( o.length > 0 )
      {
        if( getSize() != 0 )
          fireIntervalRemoved( this, 0, getSize()-1 );
        fireIntervalRemoved( this, 0, 0 );
        for( int i = 0; i < o.length; i++ )
          {
            if( !contains( o[i] ))
              mydata.add( o[i] );
          }
        fireIntervalAdded( this, 0, getSize()-1 );
      }
  }
  
  public void fireContentsChanged(Object source, int index0, int index1) 
  {
    new ListDataEvent( source, ListDataEvent.INTERVAL_ADDED, index0, index1 );
  }
}




